#include "BaseDoc.h"
#include "BaseView.h"

//NXgp錾
class MoveObject;
//Q[VXeNX
class System {
	static const int NUM;
	static System* m_pThis;
	MoveObject** m_pObjects;
	//RXgN^(singleton)
	System();
public:
	//fXgN^
	~System();
	//CX^X擾
	static System* GetInstance();
	//CX^Xj
	static void DeleteInstance();
	//IuWFNgǉ
	bool Add( MoveObject* p );
	//IuWFNg폜
	void Delete( MoveObject* p );
	//`
	void Draw( CBaseView* pView,CDC* pDC );
	//ړ
	void Move( double dTick );
	//Vbv̈ʒu̎擾
	CVector2d GetMyShipPos();
	//蔻
	void Hit();
	static inline double Rand() {
		return (double)rand() / 32768.0;
	}
};

//̃NX(ۃNXj
class MoveObject {
public:
	CVector2d m_vPos;//ʒu
	CVector2d m_vVelo;//x
	//RXgN^
	MoveObject();
	virtual void Move( double dTick );
	virtual void Draw( CBaseView* pView, CDC* pDC ) = 0;//`
	virtual bool Hit( CVector2d vLeftTop,CVector2d vRightBottom );//蔻
};

//[U[NXĩ~TCj
class Leaser : public MoveObject{
public:
	Leaser( CVector2d p, CVector2d v );
	virtual void Move( double dTick );
	virtual void Draw( CBaseView* pView, CDC* pDC );
};

//VbvijNX
class MyShip : public MoveObject{
public:
	MyShip();
	virtual void Move( double dTick );
	virtual void Draw( CBaseView* pView, CDC* pDC );
};

//GANX
class EnemyA : public MoveObject {
	DWORD m_dwBorn;
public:
	EnemyA( CVector2d p );
	virtual void Move( double dTick );
	virtual void Draw( CBaseView* pView, CDC* pDC );
};

//~TCANX
class MissileA : public MoveObject {
public:
	MissileA( CVector2d from, CVector2d to );
	virtual void Move( double dTick );
	virtual void Draw( CBaseView* pView, CDC* pDC );
};
